//------------------------------------------------------------------
#property copyright "www.forex-station.com"
#property link      "www.forex-station.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  clrDeepSkyBlue
#property indicator_color2  clrSandyBrown
#property indicator_color3  clrSandyBrown
#property indicator_color4  clrDimGray
#property indicator_color5  clrDimGray
#property indicator_width1  3
#property indicator_width2  3
#property indicator_width3  3 
#property indicator_style4  STYLE_DOT
#property indicator_style5  STYLE_DOT
#property strict

//
//
//
//
//

enum maMethod
{
   ma_sma,  // Simple moving average
   ma_ema,  // Exponential moving average
   ma_smma, // Smoothed moving average
   ma_lwma, // Linear weighted moving average
   ma_lsma, // Least Squares moving average
   ma_vwma  // Volume weighted moving average
};
enum stdMethods
{
   std_builtIn, // Built in standard deviation
   std_custSam, // Custom - with sample correction
   std_custNos  // Custom - without sample correction
};

//extern ENUM_TIMEFRAMES    TimeFrame            = PERIOD_CURRENT;  // Time frame
int    TimeFrame            = PERIOD_CURRENT;  // Time frame
extern int                BandsLength          = 20;              // Bands period
extern double             BandsDeviation       = 2.0;             // Bands deviation
extern stdMethods         BandsDeviationType   = std_custNos;     // Deviation calculation type
extern ENUM_APPLIED_PRICE AppliedPrice         = PRICE_CLOSE;     // Price
extern maMethod           AppliedMaMethod      = ma_sma;          // Average method
extern double             Filter               =  0;              // Filter to use (<=0 no filter)
extern int                FilterPeriod         =  0;              // Filter period (<=0 use Bands Length)
extern bool               alertsOn             = false;           // Trun alerts on?
extern bool               alertsOnCurrent      = false;           // Alerts on current bar?
extern bool               alertsOnBBreak       = true;            // Alerts on bands break?
extern bool               alertsOnSlope        = true;            // Alerts on slope change?
extern bool               alertsOnPriceCrossMa = true;            // Alerts on price crossing average?
extern bool               alertsMessage        = true;            // Alerts should display message?
extern bool               alertsSound          = false;           // Alerts should play a sound?
extern bool               alertsEmail          = false;           // Alerts should send an email?
extern bool               alertsPush           = false;           // Alerts should send push notification?
extern bool               Interpolate          = true;            // Interpolate in multi time frame mode?
//button template start1; copy and paste
//extern string             button_note1          = "------------------------------";
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER; 
extern string             btn_text              = "BB";
extern string             btn_Font              = "Arial";
extern int                btn_FontSize          = 10;                        
extern color              btn_text_ON_color     = clrWhite;
extern color              btn_text_OFF_color    = clrRed;
extern color              btn_background_color  = clrDimGray;
extern color              btn_border_color      = clrBlack;
extern int                button_x              = 20;                                   
extern int                button_y              = 13;                                   
extern int                btn_Width             = 60;                                
extern int                btn_Height            = 20;                               
//extern string             button_note2          = "------------------------------";

bool show_data = true;
string indicatorFileName, IndicatorName, IndicatorObjPrefix,buttonId;
//button template end1; copy and paste

double ma[],maDa[],maDb[],upBand[],dnBand[], myPoint, trend[],slope[],trends[];
bool   returnBars;
//+------------------------------------------------------------------------------------------------------------------+
string GenerateIndicatorName(const string target) //don't change anything here
{
   string name = target;
   int try = 2;
   while (WindowFind(name) != -1)
   {
      name = target + " #" + IntegerToString(try++);
   }
   return name;
}
//+------------------------------------------------------------------------------------------------------------------+
int OnInit()
{
   IndicatorName = GenerateIndicatorName(btn_text);
   IndicatorObjPrefix = "__" + IndicatorName + "__";
   IndicatorShortName(IndicatorName+timeFrameToString(TimeFrame)+" bollinger bands ");    
   IndicatorDigits(Digits);
   
   double val;
   if (GlobalVariableGet(IndicatorName + "_visibility", val))
      show_data = val != 0;

   ChartSetInteger(ChartID(), CHART_EVENT_MOUSE_MOVE, 1);
   buttonId = IndicatorObjPrefix + "BBLSMA";  //don't forget to change name here
   createButton(buttonId, btn_text, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_ON_color);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_XDISTANCE, button_x);

// put init() here
   init2();
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------------------------------------------------------+
int init2()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,ma);
   SetIndexBuffer(1,maDa);
   SetIndexBuffer(2,maDb);
   SetIndexBuffer(3,upBand);
   SetIndexBuffer(4,dnBand);
   SetIndexBuffer(5,trend);
   SetIndexBuffer(6,slope);
   SetIndexBuffer(7,trends);

    //
    //
    //
    //
    //
   
    returnBars        = TimeFrame==-99;
    TimeFrame         = fmax(TimeFrame,_Period);
    myPoint = SetPoint();
   return(0);
}
//+------------------------------------------------------------------------------------------------------------------+
//don't change anything here
void createButton(string buttonID,string buttonText,int width,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
      ObjectDelete    (ChartID(),buttonID);
      ObjectCreate    (ChartID(),buttonID,OBJ_BUTTON,0,0,0);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_COLOR,txtColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_BGCOLOR,bgColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_BORDER_COLOR,borderColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_XSIZE,width);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_YSIZE,height);
      ObjectSetString (ChartID(),buttonID,OBJPROP_FONT,font);
      ObjectSetString (ChartID(),buttonID,OBJPROP_TEXT,buttonText);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_FONTSIZE,fontSize);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_CORNER,btn_corner);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_HIDDEN,1);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_XDISTANCE,9999);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_YDISTANCE,9999);
}
//+------------------------------------------------------------------------------------------------------------------+
int deinit()
{
   ObjectsDeleteAll(ChartID(), IndicatorObjPrefix);

//put deinit() here
	return(0);
}
//+------------------------------------------------------------------------------------------------------------------+
//don't change anything here
bool recalc = true;

void handleButtonClicks()
{
   if (ObjectGetInteger(ChartID(), buttonId, OBJPROP_STATE))
   {
      ObjectSetInteger(ChartID(), buttonId, OBJPROP_STATE, false);
      show_data = !show_data;
      GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
      recalc = true;
      start();
   }
}
//+------------------------------------------------------------------------------------------------------------------+
void OnChartEvent(const int id, //don't change anything here
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   handleButtonClicks();
   if (id==CHARTEVENT_OBJECT_CLICK && ObjectGet(sparam,OBJPROP_TYPE)==OBJ_BUTTON)
   
   for (int banzai=0; banzai<indicator_buffers; banzai++)
     SetIndexStyle(banzai,DRAW_LINE);
     
   if (show_data)
      {
       ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_ON_color); 
       init2();
      }
      else
      {
        ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_OFF_color);
        for (int banzai2=0; banzai2<indicator_buffers; banzai2++)
            SetIndexStyle(banzai2,DRAW_NONE);
      }     
}
//+------------------------------------------------------------------------------------------------------------------+
int start()
{

   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit=fmin(Bars-1,Bars-counted_bars);
         if (returnBars)  { ma[0] = limit+1; return(0); }
   //
   //
   //
   //
   //

   if (TimeFrame == Period())
   {
      int    tperiod = FilterPeriod; if (tperiod<=0)  tperiod=(int)BandsLength;
      double pfilter = Filter; 
      if (slope[limit]==-1) CleanPoint(limit,maDa,maDb);  
      for (int i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         double dt=0,vt=0,dt2;
         if (AppliedMaMethod<ma_vwma)
         {
            if (AppliedMaMethod == ma_lsma)
              dt = iFilter(LSMA(0, BandsLength,AppliedPrice, i),pfilter,tperiod,i,0);
            else
              dt  = iFilter(iMA(NULL,0,BandsLength,0,(int)AppliedMaMethod,AppliedPrice,i),pfilter,tperiod,i,0);
            if (BandsDeviationType==std_builtIn)
                  dt2 = iStdDev(NULL,0,BandsLength,0,(int)AppliedMaMethod,AppliedPrice,i);
            else  dt2 = iDeviation(iMA(NULL,0,1,0,0,AppliedPrice,i),BandsLength,i,BandsDeviationType==std_custSam);
         }
         else
         {
            if (BandsDeviationType==std_builtIn)
                  dt2 = iStdDev(NULL,0,BandsLength,0,MODE_SMA,AppliedPrice,i);
            else  dt2 = iDeviation(iMA(NULL,0,1,0,0,AppliedPrice,i),BandsLength,i,BandsDeviationType==std_custSam);
            for (int k = 0; k<BandsLength && i+k<Bars; k++) { dt += iMA(NULL,0,1,0,MODE_SMA,AppliedPrice,i+k)*Volume[i+k]; vt += (double)Volume[i+k]; } dt /= vt;
         }            

         //
         //
         //
         //
         //
                  
         ma[i]     = dt;
         upBand[i] = dt+BandsDeviation*dt2;
         dnBand[i] = dt-BandsDeviation*dt2;
         maDa[i]   = EMPTY_VALUE;
         maDb[i]   = EMPTY_VALUE;
         slope[i]  = (i<Bars-1) ? (ma[i]>ma[i+1])    ? 1 : (ma[i]<ma[i+1])     ? -1 : slope[i+1]  : 0; 
         trend[i]  = (i<Bars-1) ? (Low[i]<dnBand[i]) ? 1 : (High[i]>upBand[i]) ? -1 : trend[i+1]  : 0; 
         trends[i] = (i<Bars-1) ? (Close[i]>ma[i])   ? 1 : (Close[i]<ma[i])    ? -1 : trends[i+1] : 0; 
         if (slope[i] == -1) PlotPoint(i,maDa,maDb,ma);
      }
      manageAlerts();
      return(0);            
   }
   
   //
   //
   //
   //
   //
      
   limit = (int)fmax(limit,fmin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/_Period));
   if (slope[limit]==-1) CleanPoint(limit,maDa,maDb);
   for(int i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         ma[i]     = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,BandsLength,BandsDeviation,BandsDeviationType,AppliedPrice,AppliedMaMethod,Filter,FilterPeriod,alertsOn,alertsOnCurrent,alertsOnBBreak,alertsOnSlope,alertsOnPriceCrossMa,alertsMessage,alertsSound,alertsEmail,alertsPush,0,y);
         upBand[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,BandsLength,BandsDeviation,BandsDeviationType,AppliedPrice,AppliedMaMethod,Filter,FilterPeriod,alertsOn,alertsOnCurrent,alertsOnBBreak,alertsOnSlope,alertsOnPriceCrossMa,alertsMessage,alertsSound,alertsEmail,alertsPush,3,y);
         dnBand[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,BandsLength,BandsDeviation,BandsDeviationType,AppliedPrice,AppliedMaMethod,Filter,FilterPeriod,alertsOn,alertsOnCurrent,alertsOnBBreak,alertsOnSlope,alertsOnPriceCrossMa,alertsMessage,alertsSound,alertsEmail,alertsPush,4,y);
         slope[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,BandsLength,BandsDeviation,BandsDeviationType,AppliedPrice,AppliedMaMethod,Filter,FilterPeriod,alertsOn,alertsOnCurrent,alertsOnBBreak,alertsOnSlope,alertsOnPriceCrossMa,alertsMessage,alertsSound,alertsEmail,alertsPush,6,y);
         maDa[i]   = EMPTY_VALUE;
         maDb[i]   = EMPTY_VALUE;
         if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                  
         //
         //
         //
         //
         //
                  
         int n,j; datetime time = iTime(NULL,TimeFrame,y);
            for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) continue;	
            for(j = 1; j<n && (i+n)<Bars && (i+j)<Bars; j++)
            {
               upBand[i+j] = upBand[i] + (upBand[i+n] - upBand[i])*j/n;
               dnBand[i+j] = dnBand[i] + (dnBand[i+n] - dnBand[i])*j/n;
               ma[i+j]     = ma[i]     + (ma[i+n]     - ma[i]    )*j/n;
            }                              
   }
   for (int i=limit;i>=0;i--) if (slope[i]==-1) PlotPoint(i,maDa,maDb,ma);
   return(0);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

#define filterInstances 1
double workFil[][filterInstances*3];

#define _fchange 0
#define _fachang 1
#define _fprice  2

double iFilter(double tprice, double filter, int period, int i, int instanceNo=0)
{
   if (filter<=0 || period<=0) return(tprice);
   if (ArrayRange(workFil,0)!= Bars) ArrayResize(workFil,Bars); i = Bars-i-1; instanceNo*=3;
   
   //
   //
   //
   //
   //
   
   workFil[i][instanceNo+_fprice]  = tprice; if (i<1) return(tprice);
   workFil[i][instanceNo+_fchange] = MathAbs(workFil[i][instanceNo+_fprice]-workFil[i-1][instanceNo+_fprice]);
   workFil[i][instanceNo+_fachang] = workFil[i][instanceNo+_fchange];

   for (int k=1; k<period && (i-k)>=0; k++) workFil[i][instanceNo+_fachang] += workFil[i-k][instanceNo+_fchange];
                                            workFil[i][instanceNo+_fachang] /= period;
    
   double stddev = 0; for (int k=0;  k<period && (i-k)>=0; k++) stddev += MathPow(workFil[i-k][instanceNo+_fchange]-workFil[i-k][instanceNo+_fachang],2);
          stddev = MathSqrt(stddev/(double)period); 
   double filtev = filter * stddev;
   if( MathAbs(workFil[i][instanceNo+_fprice]-workFil[i-1][instanceNo+_fprice]) < filtev ) workFil[i][instanceNo+_fprice]=workFil[i-1][instanceNo+_fprice];
   return(workFil[i][instanceNo+_fprice]);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//


double workDev[];
double iDeviation(double value, int length, int i, bool isSample=false)
{
   if (ArraySize(workDev)!=Bars) ArrayResize(workDev,Bars);  i = Bars-i-1; workDev[i] = value;
      double sumx=0,sumxx=0; for (int k=0; k<length && (i-k)>=0; sumx+=workDev[i-k],sumxx+=workDev[i-k]*workDev[i-k],k++) {}
   return(MathSqrt((sumxx-sumx*sumx/length)/fmax(length-isSample,1)));
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                          second[i] = EMPTY_VALUE; }
}

//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0; 
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnBBreak && trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] ==  1) doAlert(time1,mess1,whichBar," low price closed below lower band ");
            if (trend[whichBar] == -1) doAlert(time1,mess1,whichBar," high price closed above upper band ");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnSlope && slope[whichBar] != slope[whichBar+1])
         {
            if (slope[whichBar] ==  1) doAlert(time2,mess2,whichBar," bands ma sloping up ");
            if (slope[whichBar] == -1) doAlert(time2,mess2,whichBar," bands ma sloping down ");
         } 
      static datetime time3 = 0;
      static string   mess3 = "";
         if (alertsOnPriceCrossMa && trends[whichBar] != trends[whichBar+1])
         {
            if (trends[whichBar] ==  1) doAlert(time3,mess3,whichBar," price crossing center ma up ");
            if (trends[whichBar] == -1) doAlert(time3,mess3,whichBar," price crossing center ma down ");
         }                       
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  Symbol()+" "+timeFrameToString(_Period)+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Bollinger Band "),message);
             if (alertsPush)    SendNotification(message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

double LSMA(int iTimeFrame, int LSMAPeriod, int LSMAPrice,int shift)
{
   double wt;
   
   double ma1=iMA(NULL,iTimeFrame,LSMAPeriod,0,MODE_SMA ,LSMAPrice,shift);
   double ma2=iMA(NULL,iTimeFrame,LSMAPeriod,0,MODE_LWMA,LSMAPrice,shift);
   wt = MathFloor((3.0*ma2-2.0*ma1)/myPoint)*myPoint;
   return(wt);
}  

double SetPoint()
{
   double mPoint;
   
   if (Digits < 4)
      mPoint = 0.01;
   else
      mPoint = 0.0001;
   
   return(mPoint);
}
