//+------------------------------------------------------------------+
//|                                     C12_UltimateRoundNumbers.mq4 |
//+------------------------------------------------------------------+
#property copyright   "https://www.forexfactory.com/c-12"
#property link        "https://www.forexfactory.com/c-12"
#property strict
#property indicator_chart_window
//---
input uint  GridStep=100;//Step, pips
extern string custom_grid=" type your custom grid pair separate by comma";

input string grid_1000_pairs="HKG33,JPN225,USDNOK,USDPLN,USDSEK,USDCNH,USDTRY";
input string grid_10000_pairs="BCHUSD,LTCUSD,DSHUSD,USDRUB";
input string grid_100000_pairs="ETHUSD";
input string grid_1000000_pairs="BTCUSD";

input string grid_500_pairs=".US30Cash,.USTECHCash,.DE30Cash,ESP35,WTI,BRENT";
input string grid_5000_pairs="XAUUSD,XRPUSD,USDCZK,USDMXN,USDZAR";
input string grid_50000_pairs="USDHUF";
input string grid_500000_pairs="";

input color LineColor=clrGreen;//Color
input ENUM_LINE_STYLE LineStyle=STYLE_SOLID;//Style
input int LineWidth=2;
input string LineText="RoundNr_10";//Prefixzzzz
//button template start1; copy and paste
extern string             button_note1          = "------------------------------";
extern int                btn_Subwindow = 0;
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER; 
extern string             btn_text              = "NUMBER";
extern string             btn_Font              = "Arial";
extern int                btn_FontSize          = 10;                        
extern color              btn_text_ON_color     = clrWhite;
extern color              btn_text_OFF_color    = clrRed;
extern color              btn_background_color  = clrDimGray;
extern color              btn_border_color      = clrBlack;
extern int                button_x              = 20;                                   
extern int                button_y              = 13;                                   
extern int                btn_Width             = 60;                                
extern int                btn_Height            = 20;                               
extern string             button_note2          = "------------------------------";

bool show_data = true;
bool recalc    = true;
string indicatorFileName, IndicatorName, IndicatorObjPrefix,buttonId;
//button template end1; copy and paste
//---

string G1000[];
string G10000[];
string G100000[];
string G1000000[];

string G500[];
string G5000[];
string G50000[];
string G500000[];
//+------------------------------------------------------------------------------------------------------------------+
//button template start2; copy and paste
string GenerateIndicatorName(const string target) 
{
   string name = target;
   int try = 2;
   while (WindowFind(name) != -1)
   {
      name = target + " #" + IntegerToString(try++);
   }
   return name;
}
//+------------------------------------------------------------------------------------------------------------------+
int OnInit()
{
IndicatorName = GenerateIndicatorName(btn_text);
   IndicatorObjPrefix = "__" + IndicatorName + "__";
   IndicatorShortName(IndicatorName);
   IndicatorDigits(Digits);
   
   double val;
   if (GlobalVariableGet(IndicatorName + "_visibility", val))
      show_data = val != 0;

   indicatorFileName = WindowExpertName();
   
   ChartSetInteger(0, CHART_EVENT_MOUSE_MOVE, 1);
   buttonId = IndicatorObjPrefix + (btn_text);
   createButton(buttonId, btn_text, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_ON_color);
   ObjectSetInteger(0, buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(0, buttonId, OBJPROP_XDISTANCE, button_x);
return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------------------------------------------------------+
void OnDeinit(const int reason) { 
     ObjectsDeleteAll(ChartID(), IndicatorObjPrefix);
     ObjectsDeleteAll(0,LineText,0,-1);
     ChartRedraw();
}
//+------------------------------------------------------------------+
void createButton(string buttonID,string buttonText,int width2,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
      ObjectDelete    (0,buttonID);
      ObjectCreate    (0,buttonID,OBJ_BUTTON,btn_Subwindow,0,0);
      ObjectSetInteger(0,buttonID,OBJPROP_COLOR,txtColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BGCOLOR,bgColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_COLOR,borderColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_TYPE,BORDER_RAISED);
      ObjectSetInteger(0,buttonID,OBJPROP_XSIZE,width2);
      ObjectSetInteger(0,buttonID,OBJPROP_YSIZE,height);
      ObjectSetString (0,buttonID,OBJPROP_FONT,font);
      ObjectSetString (0,buttonID,OBJPROP_TEXT,buttonText);
      ObjectSetInteger(0,buttonID,OBJPROP_FONTSIZE,fontSize);
      ObjectSetInteger(0,buttonID,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(0,buttonID,OBJPROP_CORNER,btn_corner);
      ObjectSetInteger(0,buttonID,OBJPROP_HIDDEN,1);
      ObjectSetInteger(0,buttonID,OBJPROP_XDISTANCE,9999);
      ObjectSetInteger(0,buttonID,OBJPROP_YDISTANCE,9999);
}
//+------------------------------------------------------------------+
void handleButtonClicks()
{
   if (ObjectGetInteger(0, buttonId, OBJPROP_STATE))
   {
      ObjectSetInteger(0, buttonId, OBJPROP_STATE, false);
      show_data = !show_data;
      GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
      recalc = true;
   }
}
//+------------------------------------------------------------------------------------------------------------------+
void OnChartEvent(const int id, 
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   handleButtonClicks();
   if (id==CHARTEVENT_OBJECT_CLICK && ObjectGet(sparam,OBJPROP_TYPE)==OBJ_BUTTON)
   start2();
   if (show_data)
      {
       ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_ON_color); 
       start2();
      }
      else
      {
        ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_OFF_color);
        ObjectsDeleteAll(0,LineText,0,-1);
        ChartRedraw();
      } 
}
//button template end2; copy and paste
//+------------------------------------------------------------------------------------------------------------------+
int start2()
  {
   int tot;
   if (show_data)
      {
     {
      double Highest=High[ArrayMaximum(High)];
      double Lowest=Low[ArrayMinimum(Low)];

      int coef_point=(_Digits==1 || _Digits==3 || _Digits==5)?10:1;
      
     uint GS=GridStep; 
    ushort u_sep=StringGetCharacter(",",0); 


    StringSplit(grid_1000_pairs,u_sep,G1000);
    tot=ArraySize(G1000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G1000[x])>=0)GS=1000;
    
    }
    
    StringSplit(grid_1000_pairs,u_sep,G1000);
    tot=ArraySize(G1000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G1000[x])>=0)GS=1000;   
    }
    
    StringSplit(grid_10000_pairs,u_sep,G10000);
    tot=ArraySize(G10000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G10000[x])>=0)GS=10000;    
    }
    
    StringSplit(grid_100000_pairs,u_sep,G100000);
    tot=ArraySize(G100000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G100000[x])>=0)GS=100000;    
    }
    
    StringSplit(grid_1000000_pairs,u_sep,G1000000);
    tot=ArraySize(G1000000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G1000000[x])>=0)GS=1000000;    
    }


    StringSplit(grid_500_pairs,u_sep,G500);
    tot=ArraySize(G500);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G500[x])>=0)GS=500;    
    }

    StringSplit(grid_5000_pairs,u_sep,G5000);
     tot=ArraySize(G5000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G5000[x])>=0)GS=5000;    
    }

    StringSplit(grid_50000_pairs,u_sep,G50000);
     tot=ArraySize(G50000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G50000[x])>=0)GS=50000;    
    }    
    
    StringSplit(grid_500000_pairs,u_sep,G500000);
     tot=ArraySize(G500000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G500000[x])>=0)GS=500000;    
    }

      
      double Step=fmax(1,GS)*_Point*coef_point;

      double Max=round(1.1*Highest/Step)*Step;
      double Min=round(0.8*Lowest/Step)*Step;

      for(double i=Min; i<=Max; i+=Step)
        {
         string obj_name=LineText+"_"+DoubleToString(i,_Digits);

         if(ObjectFind(0,obj_name)==0 || 
            ObjectCreate(0,obj_name,OBJ_HLINE,0,0,i))
           {
            ObjectSetInteger(0,obj_name,OBJPROP_STYLE,LineStyle);
            ObjectSetInteger(0,obj_name,OBJPROP_COLOR,LineColor);
            ObjectSetInteger(0,obj_name,OBJPROP_WIDTH,LineWidth);
            ObjectSetInteger(0,obj_name,OBJPROP_SELECTABLE,False);
            ObjectSetDouble(0,obj_name,OBJPROP_PRICE,i);
           }
        }
//      ChartRedraw();
     }
//---
}
   return(0);
  }
//+------------------------------------------------------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   
 //if(TimeCurrent()>D'2020.02.18'){Alert("indi expired");ObjectsDeleteAll(); ExpertRemove();return(INIT_FAILED);}
   if (show_data)
      {

   if(prev_calculated==0)
     {
      double Highest=High[ArrayMaximum(High)];
      double Lowest=Low[ArrayMinimum(Low)];

      int coef_point=(_Digits==1 || _Digits==3 || _Digits==5)?10:1;
      
     uint GS=GridStep; 
    ushort u_sep=StringGetCharacter(",",0); 


    StringSplit(grid_1000_pairs,u_sep,G1000);
    int tot=ArraySize(G1000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G1000[x])>=0)GS=1000;
    
    }
    
    StringSplit(grid_10000_pairs,u_sep,G10000);
     tot=ArraySize(G10000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G10000[x])>=0)GS=10000;    
    }
    
    StringSplit(grid_100000_pairs,u_sep,G100000);
     tot=ArraySize(G100000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G100000[x])>=0)GS=100000;    
    }
    
    StringSplit(grid_1000000_pairs,u_sep,G1000000);
     tot=ArraySize(G1000000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G1000000[x])>=0)GS=1000000;    
    }


    StringSplit(grid_500_pairs,u_sep,G500);
     tot=ArraySize(G500);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G500[x])>=0)GS=500;    
    }

    StringSplit(grid_5000_pairs,u_sep,G5000);
     tot=ArraySize(G5000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G5000[x])>=0)GS=5000;    
    }

    StringSplit(grid_50000_pairs,u_sep,G50000);
     tot=ArraySize(G50000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G50000[x])>=0)GS=50000;    
    }    
    
    StringSplit(grid_500000_pairs,u_sep,G500000);
     tot=ArraySize(G500000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G500000[x])>=0)GS=500000;    
    }

      
      double Step=fmax(1,GS)*_Point*coef_point;

      double Max=round(1.1*Highest/Step)*Step;
      double Min=round(0.8*Lowest/Step)*Step;

      //Print(Max," ",Min," ",Step);

      for(double i=Min; i<=Max; i+=Step)
        {
         string obj_name=LineText+"_"+DoubleToString(i,_Digits);

         if(ObjectFind(0,obj_name)==0 || 
            ObjectCreate(0,obj_name,OBJ_HLINE,0,0,i))
           {
            ObjectSetInteger(0,obj_name,OBJPROP_STYLE,LineStyle);
            ObjectSetInteger(0,obj_name,OBJPROP_COLOR,LineColor);
            ObjectSetInteger(0,obj_name,OBJPROP_WIDTH,LineWidth);
            ObjectSetInteger(0,obj_name,OBJPROP_SELECTABLE,False);
            ObjectSetDouble(0,obj_name,OBJPROP_PRICE,i);
           }
        }

//      ChartRedraw();
     }
//---
}
   return(rates_total);
  }
//+------------------------------------------------------------------+
